"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var UniqueID_1 = require("../utils/UniqueID");
/**
 * @author Bram Willem van der Kuip <vdkuipb@gmail.com>
 */
var GameObject = /** @class */ (function () {
    /**
     * Creates an instance of GameObject.
     * @param {string} [id=UniqueID.generate()]
     */
    function GameObject(id) {
        if (id === void 0) { id = UniqueID_1.UniqueID.generate(); }
        this.id = id;
    }
    /**
     *
     * @param {number} delta
     */
    GameObject.prototype.update = function (delta) {
    };
    /**
     *
     */
    GameObject.prototype.destroyInstance = function () {
        delete this.id;
    };
    return GameObject;
}());
exports.GameObject = GameObject;
