const bufferList = require('../vendor/websocket/vendor/FastBufferList.js');
const tempWebSocketFrame = require('../vendor/websocket/lib/WebSocketFrame.js');

/**
 * TODO: Make constants.
 * TODO: Rename functions.
 *
 * @author Bram Willem van der Kuip <vdkuipb@gmail.com>
 */
export class WebSocketFrame {

    /**
     *
     * @param {object} data
     * @returns {*}
     */
    public static to(data: object): any {
        const frame = new tempWebSocketFrame(
            Buffer.alloc(4),
            Buffer.alloc(10),
            { maxReceivedFrameSize: 0x10000 },
        );

        let dataString;
        try {
            dataString = JSON.stringify(data);
        } catch (error) {

        }

        frame.binaryPayload = Buffer.from(dataString);
        frame.opcode = 0x01;
        frame.fin = true;

        return frame;
    }

    /**
     *
     * @param {object} data
     * @returns {*}
     */
    public static from(data: object): any {
        const buffer = new bufferList();
        buffer.write(data);
        const frame = new tempWebSocketFrame(
            Buffer.alloc(4),
            Buffer.alloc(10),
            { maxReceivedFrameSize: 0x10000 },
        );
        frame.addData(buffer);
        return frame;
    }
}
