/**
 * @author Bram Willem van der Kuip <vdkuipb@gmail.com>
 */
export interface Message {
    event: number | string;
    data: any;
}
/**
 * TODO: rename.
 *
 * @author Bram Willem van der Kuip <vdkuipb@gmail.com>
 */
export declare class MessageFormatter {
    /**
     *
     * @param {Message} message
     * @returns {string}
     */
    static encrypt(message: Message): string;
    /**
     *
     * @param {object} data
     * @return {Message}
     */
    static decrypt(data: object): Message;
    /**
     * Checks if object implements the Message interface.
     * @param {*} data The object the check if is a message.
     * @returns {boolean} The flag if it is true of not.
     */
    static isMessage(data: any): boolean;
}
