/// <reference types="node" />
import { Socket } from 'net';
import { Destroyable } from '../utils/Destroyable';
/**
 * @author Bram Willem van der Kuip <vdkuipb@gmail.com>
 */
export declare class SocketKeepAlive implements Destroyable {
    /**
     *
     */
    private socket;
    /**
     *
     */
    private keepAlive;
    /**
     *
     */
    private connectionTimer;
    /**
     *
     */
    private latency;
    /**
     *
     */
    private lastPing;
    /**
     *
     */
    private boundCheckConnection;
    private boundTimedOut;
    /**
     * Creates an instance of SocketKeepAlive.
     */
    constructor(socket: Socket);
    /**
     * TODO: Move variable to config/constant file.
     */
    private reset;
    /**
     *
     */
    private stop;
    /**
     * TODO: Move variable to config/constant file.
     */
    private check;
    /**
     * TODO: Do something with the latency data. Prob something with events and sending it out.
     */
    finish(): void;
    /**
     *
     */
    private clear;
    /**
     * TODO: Do something when socket is timed out. Prob closing the connection.
     */
    private timedOut;
    /**
     * TODO: Move creation of this object to constant and to WebSocketFrame class.
     */
    sendPing(): void;
    /**
     * Destroys this instance of SocketKeepAlive.
     */
    destroyInstance(): void;
}
