"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var bufferList = require('../vendor/websocket/vendor/FastBufferList.js');
var tempWebSocketFrame = require('../vendor/websocket/lib/WebSocketFrame.js');
/**
 * TODO: Make constants.
 * TODO: Rename functions.
 *
 * @author Bram Willem van der Kuip <vdkuipb@gmail.com>
 */
var WebSocketFrame = /** @class */ (function () {
    function WebSocketFrame() {
    }
    /**
     *
     * @param {object} data
     * @returns {*}
     */
    WebSocketFrame.to = function (data) {
        var frame = new tempWebSocketFrame(Buffer.alloc(4), Buffer.alloc(10), { maxReceivedFrameSize: 0x10000 });
        var dataString;
        try {
            dataString = JSON.stringify(data);
        }
        catch (error) {
        }
        frame.binaryPayload = Buffer.from(dataString);
        frame.opcode = 0x01;
        frame.fin = true;
        return frame;
    };
    /**
     *
     * @param {object} data
     * @returns {*}
     */
    WebSocketFrame.from = function (data) {
        var buffer = new bufferList();
        buffer.write(data);
        var frame = new tempWebSocketFrame(Buffer.alloc(4), Buffer.alloc(10), { maxReceivedFrameSize: 0x10000 });
        frame.addData(buffer);
        return frame;
    };
    return WebSocketFrame;
}());
exports.WebSocketFrame = WebSocketFrame;
